/* $Id: crires_recipe.h,v 1.9 2012-01-16 09:29:23 yjung Exp $
 *
 * This file is part of the CRIRES Pipeline
 * Copyright (C) 2002,2003 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02111-1307  USA
 */

/*
 * $Author: yjung $
 * $Date: 2012-01-16 09:29:23 $
 * $Revision: 1.9 $
 * $Name: not supported by cvs2svn $
 */

/* cpp macros that must be defined before inclusion:

   RECIPE_NAME:         e.g. crires_spec_jitter
   RECIPE_STRING:       e.g. "crires_spec_jitter"
   RECIPE_SYNOPSIS:     String with the recipe synopsis
   RECIPE_DESCRIPTION:  String with the recipe descrption
   Optionally:
   RECIPE_PARAMS:       Binary or of parameter enums

*/


#ifndef CRIRES_RECIPE_H
#define CRIRES_RECIPE_H

/*-----------------------------------------------------------------------------
                                Includes
 -----------------------------------------------------------------------------*/

#include <math.h>
#include <assert.h>
#include <float.h>
#include <string.h>

#include <cpl.h>

#include "irplib_plugin.h"

#include "crires_parameter.h"
#include "crires_utils.h"
#include "crires_load.h"
#include "crires_pfits.h"
#include "crires_dfs.h"

/*-----------------------------------------------------------------------------
                                Defines
 -----------------------------------------------------------------------------*/

#define crires_pipe_id PACKAGE "/" PACKAGE_VERSION

#define CRIRES_RECIPE_DEFINE(RECIPE_NAME, RECIPE_PARAMS, SYNOPSIS, DESCRIPTION) \
    cpl_recipe_define(RECIPE_NAME, CRIRES_BINARY_VERSION,               \
                      "Yves Jung", PACKAGE_BUGREPORT, "2002 - 2012",    \
                      SYNOPSIS, DESCRIPTION);                           \
                                                                        \
    static cpl_error_code CPL_CONCAT2X(RECIPE_NAME,fill_parameterlist)  \
        (cpl_parameterlist * self) {                                    \
        return crires_parameter_set(self, #RECIPE_NAME, RECIPE_PARAMS)   \
            ? cpl_error_set_where(cpl_func) : CPL_ERROR_NONE;           \
    }                                                                   \
    extern int CPL_CONCAT2X(RECIPE_NAME,plugin_end)

#endif
